"""enemy character"""

import mob
import random
import projectile
import const

class Enemy(mob.Mob):
    maxvel = const.enemy_maxvel
    start_y = 1024.0
    start_x_min = 50.0
    start_x_max = 2030.0

    def __init__(self, g, coll_handler, type = 'eggboy'):
        y = Enemy.start_y
        x = Enemy.start_x_min + random.random() * \
            (Enemy.start_x_max - Enemy.start_x_min)
        super(Enemy, self).__init__(g, x, y, type)
        self.kind = 'enemy'
        self.coll_handler = coll_handler
        self.decision_timer = 0.0


    def collision(self, mob):
        if mob.kind == 'projectile':
            #print "enemy got hit: %s" % mob.active
            if mob.active and mob.owner != self:
                if random.random() > 0.5:
                    self.g.sounddict['boink'].play()
                else:
                    self.g.sounddict['bong'].play()
                self.coll_handler(self)
        else:
            self.moving = False


    # artificial intelligence
    def ai(self):
        self.decision_timer -= self.g.dt
        if self.decision_timer > 0.0:
            return
        self.decision_timer = random.random() * 5.0 + 1.0

        if int(random.random() * 5) == 0:
            # throw an egg
            #target = self.g.scene.moblist[int(random.random() * \
            #                                  len(self.g.scene.moblist))]
            target = self.g.scene.george
            self.throw(target.x, target.y)
        else:
            # move around
            self.dir = random.random() * 360.0
            self.vel = Enemy.maxvel
            self.moving = True

        
    def simstep(self):
        self.ai()
        super(Enemy, self).simstep()


    def throw(self, x = 0, y = 0):
        type = 'egg'
        proj = projectile.Projectile(self.g, self, x, y, type)
        self.g.scene.moblist.append(proj)

