"""Ground (grass)"""

import pyglet
import misc
from pyglet.gl import *

class Ground:

    def __init__(self):
        self.size = 8192.0
        self.img = pyglet.image.load(misc.imagepath('grass_tex.png'))
        self.tex = self.img.get_texture()
        self.scalex = self.size / float(self.img.width)
        self.scaley = self.size / float(self.img.height)


    def draw(self):
        glEnable(self.tex.target)
        glBindTexture(self.tex.target, self.tex.id)
        t = self.tex.tex_coords
        glBegin(GL_QUADS)
        glTexCoord2f(t[0] * self.scalex, t[1] * self.scaley)
        glVertex3f(-self.size, -self.size,  0.0)
        glTexCoord2f(t[3] * self.scalex, t[4] * self.scaley)
        glVertex3f( self.size, -self.size,  0.0)
        glTexCoord2f(t[6] * self.scalex, t[7] * self.scaley)
        glVertex3f( self.size,  self.size,  0.0)
        glTexCoord2f(t[9] * self.scalex, t[10] * self.scaley)
        glVertex3f(-self.size,  self.size, 0.0)
        glEnd()
