"""Movable object sprite"""

from pyglet.gl import *
import misc

class Mobsprite(object):
    DEBUG = False
    
    def __init__(self, g, x = 0, y = 0, type = 'george'):
        self._x = x
        self._y = y
        self.type = type
        self.image = g.imagedict[type]
        self.tex = self.image.get_texture()
        self.rot = 0   # 0 is normal, 1 is 90 ccw, 2 i 90 cw, 3 is ground


    def set_position(self, x, y):
        self._x = x
        self._y = y


    def dump(self):
        dumpdict = {}
        dumpdict['type'] = self.type
        dumpdict['x'] = self._x
        dumpdict['y'] = self._y
        return dumpdict
        

    def draw(self, facing = 'right'):
        offset = self.image.width / 2
        height = self.image.height
        glTranslatef(self._x, self._y, 0.0)
        glEnable(self.tex.target)
        glBindTexture(self.tex.target, self.tex.id)
        t = self.tex.tex_coords
        glBegin(GL_QUADS)
        if self.rot == 1:  # 90 ccw
            glTexCoord2f(t[0],t[1]); glVertex3f(0.0, -offset, 0.0);
            glTexCoord2f(t[3],t[4]); glVertex3f(0.0, offset, 0.0);
            glTexCoord2f(t[6],t[7]); glVertex3f(0.0, offset, height);
            glTexCoord2f(t[9],t[10]); glVertex3f(0.0, -offset, height);
        elif self.rot == 3:  # on ground
            glTexCoord2f(t[0],t[1]); glVertex3f(-offset, 0.0, 0.0);
            glTexCoord2f(t[3],t[4]); glVertex3f( offset, 0.0, 0.0);
            glTexCoord2f(t[6],t[7]); glVertex3f( offset, height, 0.0);
            glTexCoord2f(t[9],t[10]); glVertex3f(-offset, height, 0.0);
        else:
            if facing == 'right':
                glTexCoord2f(t[0],t[1]); glVertex3f(-offset, 0.0, 0.0);
                glTexCoord2f(t[3],t[4]); glVertex3f( offset, 0.0, 0.0);
                glTexCoord2f(t[6],t[7]); glVertex3f( offset, 0.0, height);
                glTexCoord2f(t[9],t[10]); glVertex3f(-offset, 0.0, height);
            else:
                glTexCoord2f(t[0],t[1]); glVertex3f( offset, 0.0, 0.0);
                glTexCoord2f(t[3],t[4]); glVertex3f(-offset, 0.0, 0.0);
                glTexCoord2f(t[6],t[7]); glVertex3f(-offset, 0.0, height);
                glTexCoord2f(t[9],t[10]); glVertex3f(offset, 0.0, height);
        glEnd();
        if Mobsprite.DEBUG == True:
            glLineWidth(1.0)
            glColor3f(0.0, 0.0, 0.0)
            glDisable(GL_TEXTURE_2D)
            glBegin(GL_LINE_LOOP)
            glVertex3f(-offset, 0.0, 0.0);
            glVertex3f( offset, 0.0, 0.0);
            glVertex3f( offset, 0.0, height);
            glVertex3f(-offset, 0.0, height);
            glEnd()
            glColor3f(1.0, 1.0, 1.0)
        glTranslatef(-self._x, -self._y, 0.0)
