"""Reticule (target marker)"""

import pyglet
import misc
from pyglet.gl import *

class Reticule:
    def __init__(self):
        self.x, self.y, self.z = 0.0, 0.0, 0.0
        self.img = pyglet.image.load(misc.imagepath('reticule.png'))
        self.tex = self.img.get_texture()

    # Takes screen (mouse) coordinates and calculates new reticule position
    def update_position(self, screen_x, screen_y):
        self.x, self.y, self.z = misc.screen_to_world(screen_x, screen_y)


    def draw(self):
        glEnable(self.tex.target)
        glBindTexture(self.tex.target, self.tex.id)
        t = self.tex.tex_coords
        glBegin(GL_QUADS)
        glTexCoord2f(t[0],t[1])
        glVertex3f(self.x - self.img.width,
                   self.y - self.img.height, self.z)
        glTexCoord2f(t[3],t[4])
        glVertex3f(self.x + self.img.width,
                   self.y - self.img.height, self.z)
        glTexCoord2f(t[6],t[7])
        glVertex3f(self.x + self.img.width,
                   self.y + self.img.height, self.z)
        glTexCoord2f(t[9],t[10])
        glVertex3f(self.x - self.img.width,
                   self.y + self.img.height, self.z)
        glEnd()

        
